searchNodes=[{"type":"module","title":"AshAdmin.Api","doc":"An API extension to alter the behavior of an API in the admin UI. Table of Contents: admin DSL Docs: admin Configure the admin dashboard for a given API. :name ( String.t/0 ) - The name of the API in the dashboard. Will be derived if not set. :show? ( boolean/0 ) - Whether or not this API and its resources should be included in the admin dashboard. The default value is false . :default_resource_page - Set the default page for the resource to be the primary read action or the resource schema. Schema is the default for backwards compatibility, if a resource doesn't have a primary read action it will fallback to the schema view. Valid values are :schema, :primary_read The default value is :schema . :resource_group_labels ( keyword/0 ) - Humanized names for each resource group to appear in the admin area. These will be used as labels in the top navigation dropdown. If a key for a group does not appear in this mapping, the label will not be rendered. The default value is [] .","ref":"AshAdmin.Api.html"},{"type":"function","title":"AshAdmin.Api.default_resource_page/1","doc":"","ref":"AshAdmin.Api.html#default_resource_page/1"},{"type":"function","title":"AshAdmin.Api.name/1","doc":"","ref":"AshAdmin.Api.html#name/1"},{"type":"function","title":"AshAdmin.Api.resource_group_labels/1","doc":"","ref":"AshAdmin.Api.html#resource_group_labels/1"},{"type":"function","title":"AshAdmin.Api.show?/1","doc":"","ref":"AshAdmin.Api.html#show?/1"},{"type":"module","title":"AshAdmin.CoreComponents","doc":"Provides core UI components. At the first glance, this module may seem daunting, but its goal is to provide some core building blocks in your application, such as modals, tables, and forms. The components are mostly markup and well documented with doc strings and declarative assigns. You may customize and style them in any way you want, based on your application growth and needs. The default components use Tailwind CSS, a utility-first CSS framework. See the Tailwind CSS documentation to learn how to customize them or feel free to swap in another framework altogether. Icons are provided by heroicons . See icon/1 for usage.","ref":"AshAdmin.CoreComponents.html"},{"type":"function","title":"AshAdmin.CoreComponents.back/1","doc":"Renders a back navigation link. Examples &lt; . back navigate = { ~p&quot;/posts&quot; } &gt; Back to posts &lt; / . back &gt; Attributes navigate ( :any ) (required) Slots inner_block (required)","ref":"AshAdmin.CoreComponents.html#back/1"},{"type":"function","title":"AshAdmin.CoreComponents.button/1","doc":"Renders a button. Examples &lt; . button &gt; Send ! &lt; / . button &gt; &lt; . button phx - click = &quot;go&quot; class = &quot;ml-2&quot; &gt; Send ! &lt; / . button &gt; Attributes type ( :string ) - Defaults to nil . class ( :string ) - Defaults to nil . Global attributes are accepted. Slots inner_block (required)","ref":"AshAdmin.CoreComponents.html#button/1"},{"type":"function","title":"AshAdmin.CoreComponents.error/1","doc":"Generates a generic error message. Slots inner_block (required)","ref":"AshAdmin.CoreComponents.html#error/1"},{"type":"function","title":"AshAdmin.CoreComponents.flash/1","doc":"Renders flash notices. Examples &lt; . flash kind = { :info } flash = { @flash } / &gt; &lt; . flash kind = { :info } phx - mounted = { show ( &quot;#flash&quot; ) } &gt; Welcome Back ! &lt; / . flash &gt; Attributes id ( :string ) - the optional id of flash container. Defaults to &quot;flash&quot; . flash ( :map ) - the map of flash messages to display. Defaults to %{} . title ( :string ) - Defaults to nil . kind ( :atom ) - used for styling and flash lookup.Must be one of :info , or :error . Global attributes are accepted. Slots inner_block - the optional inner block that renders the flash message.","ref":"AshAdmin.CoreComponents.html#flash/1"},{"type":"function","title":"AshAdmin.CoreComponents.flash_group/1","doc":"Shows the flash group with standard titles and content. Examples &lt; . flash_group flash = { @flash } / &gt; Attributes flash ( :map ) (required) - the map of flash messages.","ref":"AshAdmin.CoreComponents.html#flash_group/1"},{"type":"function","title":"AshAdmin.CoreComponents.header/1","doc":"Renders a header with title. Attributes class ( :string ) - Defaults to nil . Slots inner_block (required) subtitle actions","ref":"AshAdmin.CoreComponents.html#header/1"},{"type":"function","title":"AshAdmin.CoreComponents.hide/2","doc":"","ref":"AshAdmin.CoreComponents.html#hide/2"},{"type":"function","title":"AshAdmin.CoreComponents.hide_modal/2","doc":"","ref":"AshAdmin.CoreComponents.html#hide_modal/2"},{"type":"function","title":"AshAdmin.CoreComponents.icon/1","doc":"Renders a Heroicon . Heroicons come in three styles – outline, solid, and mini. By default, the outline style is used, but solid and mini may be applied by using the -solid and -mini suffix. You can customize the size and colors of the icons by setting width, height, and background color classes. Icons are extracted from your assets/vendor/heroicons directory and bundled within your compiled app.css by the plugin in your assets/tailwind.config.js . Examples &lt; . icon name = &quot;hero-x-mark-solid&quot; / &gt; &lt; . icon name = &quot;hero-arrow-path&quot; class = &quot;ml-1 w-3 h-3 animate-spin&quot; / &gt; Attributes name ( :string ) (required) class ( :string ) - Defaults to nil .","ref":"AshAdmin.CoreComponents.html#icon/1"},{"type":"function","title":"AshAdmin.CoreComponents.input/1","doc":"Renders an input with label and error messages. A Phoenix.HTML.FormField may be passed as argument, which is used to retrieve the input name, id, and values. Otherwise all attributes may be passed explicitly. Types This function accepts all HTML input types, considering that: You may also set type=&quot;select&quot; to render a &lt;select&gt; tag type=&quot;checkbox&quot; is used exclusively to render boolean values For live file uploads, see Phoenix.Component.live_file_input/1 See https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input for more information. Examples &lt; . input field = { @form [ :email ] } type = &quot;email&quot; / &gt; &lt; . input name = &quot;my-input&quot; errors = { [ &quot;oh no!&quot; ] } / &gt; Attributes id ( :any ) - Defaults to nil . name ( :any ) label ( :string ) - Defaults to nil . value ( :any ) type ( :string ) - Defaults to &quot;text&quot; . field ( Phoenix.HTML.FormField ) - a form field struct retrieved from the form, for example: @form[:email]. errors ( :list ) - Defaults to [] . checked ( :boolean ) - the checked flag for checkbox inputs. prompt ( :string ) - the prompt for select inputs. Defaults to nil . options ( :list ) - the options to pass to Phoenix.HTML.Form.options_for_select/2. multiple ( :boolean ) - the multiple flag for select inputs. Defaults to false . Global attributes are accepted. Slots inner_block","ref":"AshAdmin.CoreComponents.html#input/1"},{"type":"function","title":"AshAdmin.CoreComponents.label/1","doc":"Renders a label. Attributes for ( :string ) - Defaults to nil . Slots inner_block (required)","ref":"AshAdmin.CoreComponents.html#label/1"},{"type":"function","title":"AshAdmin.CoreComponents.list/1","doc":"Renders a data list. Examples &lt; . list &gt; &lt; :item title = &quot;Title&quot; &gt; &lt; % = @post . title % &gt; &lt; / :item &gt; &lt; :item title = &quot;Views&quot; &gt; &lt; % = @post . views % &gt; &lt; / :item &gt; &lt; / . list &gt; Slots item (required) - Accepts attributes: title ( :string ) (required)","ref":"AshAdmin.CoreComponents.html#list/1"},{"type":"function","title":"AshAdmin.CoreComponents.modal/1","doc":"Renders a modal. Examples &lt; . modal id = &quot;confirm-modal&quot; &gt; This is a modal . &lt; / . modal &gt; JS commands may be passed to the :on_cancel to configure the closing/cancel event, for example: &lt; . modal id = &quot;confirm&quot; on_cancel = { JS . navigate ( ~p&quot;/posts&quot; ) } &gt; This is another modal . &lt; / . modal &gt; Attributes id ( :string ) (required) show ( :boolean ) - Defaults to false . on_cancel ( Phoenix.LiveView.JS ) - Defaults to %Phoenix.LiveView.JS{ops: []} . Slots inner_block (required)","ref":"AshAdmin.CoreComponents.html#modal/1"},{"type":"function","title":"AshAdmin.CoreComponents.show/2","doc":"","ref":"AshAdmin.CoreComponents.html#show/2"},{"type":"function","title":"AshAdmin.CoreComponents.show_modal/2","doc":"","ref":"AshAdmin.CoreComponents.html#show_modal/2"},{"type":"function","title":"AshAdmin.CoreComponents.simple_form/1","doc":"Renders a simple form. Examples &lt; . simple_form for = { @form } phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; . input field = { @form [ :email ] } label = &quot;Email&quot; / &gt; &lt; . input field = { @form [ :username ] } label = &quot;Username&quot; / &gt; &lt; :actions &gt; &lt; . button &gt; Save &lt; / . button &gt; &lt; / :actions &gt; &lt; / . simple_form &gt; Attributes for ( :any ) (required) - the datastructure for the form. as ( :any ) - the server side parameter to collect all input under. Defaults to nil . Global attributes are accepted. Slots inner_block (required) actions - the slot for form actions, such as a submit button.","ref":"AshAdmin.CoreComponents.html#simple_form/1"},{"type":"function","title":"AshAdmin.CoreComponents.table/1","doc":"Renders a table with generic styling. Examples &lt; . table id = &quot;users&quot; rows = { @users } &gt; &lt; :col :let = { user } label = &quot;id&quot; &gt; &lt; % = user . id % &gt; &lt; / :col &gt; &lt; :col :let = { user } label = &quot;username&quot; &gt; &lt; % = user . username % &gt; &lt; / :col &gt; &lt; / . table &gt; Attributes id ( :string ) (required) rows ( :list ) (required) row_id ( :any ) - the function for generating the row id. Defaults to nil . row_click ( :any ) - the function for handling phx-click on each row. Defaults to nil . row_item ( :any ) - the function for mapping each row before calling the :col and :action slots. Defaults to &amp;Function.identity/1 . Slots col (required) - Accepts attributes: label ( :string ) action - the slot for showing user actions in the last table column.","ref":"AshAdmin.CoreComponents.html#table/1"},{"type":"function","title":"AshAdmin.CoreComponents.translate_error/1","doc":"Translates an error message using gettext.","ref":"AshAdmin.CoreComponents.html#translate_error/1"},{"type":"function","title":"AshAdmin.CoreComponents.translate_errors/2","doc":"Translates the errors for a field from a keyword list of errors.","ref":"AshAdmin.CoreComponents.html#translate_errors/2"},{"type":"module","title":"AshAdmin.Gettext","doc":"A module providing Internationalization with a gettext-based API. By using Gettext , your module gains a set of macros for translations, for example: import AshAdmin.Gettext # Simple translation gettext ( &quot;Here is the string to translate&quot; ) # Plural translation ngettext ( &quot;Here is the string to translate&quot; , &quot;Here are the strings to translate&quot; , 3 ) # Domain-based translation dgettext ( &quot;errors&quot; , &quot;Here is the error message to translate&quot; ) See the Gettext Docs for detailed usage.","ref":"AshAdmin.Gettext.html"},{"type":"macro","title":"AshAdmin.Gettext.dgettext/3","doc":"Callback implementation for Gettext.Backend.dgettext/3 .","ref":"AshAdmin.Gettext.html#dgettext/3"},{"type":"macro","title":"AshAdmin.Gettext.dgettext_noop/2","doc":"Callback implementation for Gettext.Backend.dgettext_noop/2 .","ref":"AshAdmin.Gettext.html#dgettext_noop/2"},{"type":"macro","title":"AshAdmin.Gettext.dngettext/5","doc":"Callback implementation for Gettext.Backend.dngettext/5 .","ref":"AshAdmin.Gettext.html#dngettext/5"},{"type":"macro","title":"AshAdmin.Gettext.dngettext_noop/3","doc":"Callback implementation for Gettext.Backend.dngettext_noop/3 .","ref":"AshAdmin.Gettext.html#dngettext_noop/3"},{"type":"macro","title":"AshAdmin.Gettext.dpgettext/4","doc":"Callback implementation for Gettext.Backend.dpgettext/4 .","ref":"AshAdmin.Gettext.html#dpgettext/4"},{"type":"macro","title":"AshAdmin.Gettext.dpgettext_noop/3","doc":"","ref":"AshAdmin.Gettext.html#dpgettext_noop/3"},{"type":"macro","title":"AshAdmin.Gettext.dpngettext/6","doc":"Callback implementation for Gettext.Backend.dpngettext/6 .","ref":"AshAdmin.Gettext.html#dpngettext/6"},{"type":"macro","title":"AshAdmin.Gettext.dpngettext_noop/4","doc":"","ref":"AshAdmin.Gettext.html#dpngettext_noop/4"},{"type":"macro","title":"AshAdmin.Gettext.gettext/2","doc":"Callback implementation for Gettext.Backend.gettext/2 .","ref":"AshAdmin.Gettext.html#gettext/2"},{"type":"macro","title":"AshAdmin.Gettext.gettext_comment/1","doc":"Callback implementation for Gettext.Backend.gettext_comment/1 .","ref":"AshAdmin.Gettext.html#gettext_comment/1"},{"type":"macro","title":"AshAdmin.Gettext.gettext_noop/1","doc":"Callback implementation for Gettext.Backend.gettext_noop/1 .","ref":"AshAdmin.Gettext.html#gettext_noop/1"},{"type":"function","title":"AshAdmin.Gettext.handle_missing_bindings/2","doc":"Callback implementation for Gettext.Backend.handle_missing_bindings/2 .","ref":"AshAdmin.Gettext.html#handle_missing_bindings/2"},{"type":"function","title":"AshAdmin.Gettext.handle_missing_plural_translation/7","doc":"Callback implementation for Gettext.Backend.handle_missing_plural_translation/7 .","ref":"AshAdmin.Gettext.html#handle_missing_plural_translation/7"},{"type":"function","title":"AshAdmin.Gettext.handle_missing_translation/5","doc":"Callback implementation for Gettext.Backend.handle_missing_translation/5 .","ref":"AshAdmin.Gettext.html#handle_missing_translation/5"},{"type":"function","title":"AshAdmin.Gettext.lgettext/5","doc":"","ref":"AshAdmin.Gettext.html#lgettext/5"},{"type":"function","title":"AshAdmin.Gettext.lngettext/7","doc":"","ref":"AshAdmin.Gettext.html#lngettext/7"},{"type":"macro","title":"AshAdmin.Gettext.ngettext/4","doc":"Callback implementation for Gettext.Backend.ngettext/4 .","ref":"AshAdmin.Gettext.html#ngettext/4"},{"type":"macro","title":"AshAdmin.Gettext.ngettext_noop/2","doc":"Callback implementation for Gettext.Backend.ngettext_noop/2 .","ref":"AshAdmin.Gettext.html#ngettext_noop/2"},{"type":"macro","title":"AshAdmin.Gettext.pgettext/3","doc":"Callback implementation for Gettext.Backend.pgettext/3 .","ref":"AshAdmin.Gettext.html#pgettext/3"},{"type":"macro","title":"AshAdmin.Gettext.pgettext_noop/2","doc":"","ref":"AshAdmin.Gettext.html#pgettext_noop/2"},{"type":"macro","title":"AshAdmin.Gettext.pngettext/5","doc":"Callback implementation for Gettext.Backend.pngettext/5 .","ref":"AshAdmin.Gettext.html#pngettext/5"},{"type":"macro","title":"AshAdmin.Gettext.pngettext_noop/3","doc":"","ref":"AshAdmin.Gettext.html#pngettext_noop/3"},{"type":"module","title":"AshAdmin.Resource","doc":"An API extension to alter the behaviour of a resource in the admin UI. Table of Contents: admin form field DSL Docs: admin Configure the admin dashboard for a given resource. form field :name ( String.t/0 ) - The proper name to use when this resource appears in the admin interface. :actor? ( boolean/0 ) - Whether or not this resource can be used as the actor for requests. :show_action ( atom/0 ) - The action to use when linking to the resource/viewing a single record. Defaults to the primary read action. :read_actions (list of atom/0 ) - A list of read actions that can be used to show resource details. By default, all actions are included. :create_actions (list of atom/0 ) - A list of create actions that can create records. By default, all actions are included. :update_actions (list of atom/0 ) - A list of update actions that can be used to update records. By default, all actions are included. :destroy_actions (list of atom/0 ) - A list of destroy actions that can be used to destroy records. By default, all actions are included. :polymorphic_tables (list of String.t/0 ) - For resources that use ash_postgres' polymorphism capabilities, you can provide a list of tables that should be available to select. These will be added to the list of derivable tables based on scanning all APIs and resources provided to ash_admin. :polymorphic_actions (list of atom/0 ) - For resources that use ash_postgres' polymorphism capabilities, you can provide a list of actions that should require a table to be set. If this is not set, then all actions will require tables. :table_columns (list of atom/0 ) - The list of attributes to render on the table view. :format_fields (list of term/0 ) - The list of fields and their formats. :relationship_display_fields (list of atom/0 ) - The list of attributes to render when it's shown as a relationship on a datatable :resource_group ( atom/0 ) - The group in the top resource dropdown that the resource appears in. form Configure the appearance of fields in admin forms. field field Declare non-default behavior for a specific attribute. :name ( atom/0 ) - Required. The name of the field to be modified :type - Required. The type of the value in the form. Use default if you are just specifying field order Valid values are :default, :long_text, :short_text, :markdown","ref":"AshAdmin.Resource.html"},{"type":"function","title":"AshAdmin.Resource.actor?/1","doc":"","ref":"AshAdmin.Resource.html#actor?/1"},{"type":"function","title":"AshAdmin.Resource.create_actions/1","doc":"","ref":"AshAdmin.Resource.html#create_actions/1"},{"type":"function","title":"AshAdmin.Resource.destroy_actions/1","doc":"","ref":"AshAdmin.Resource.html#destroy_actions/1"},{"type":"function","title":"AshAdmin.Resource.field/2","doc":"","ref":"AshAdmin.Resource.html#field/2"},{"type":"function","title":"AshAdmin.Resource.fields/1","doc":"","ref":"AshAdmin.Resource.html#fields/1"},{"type":"function","title":"AshAdmin.Resource.format_fields/1","doc":"","ref":"AshAdmin.Resource.html#format_fields/1"},{"type":"function","title":"AshAdmin.Resource.name/1","doc":"","ref":"AshAdmin.Resource.html#name/1"},{"type":"function","title":"AshAdmin.Resource.polymorphic_actions/1","doc":"","ref":"AshAdmin.Resource.html#polymorphic_actions/1"},{"type":"function","title":"AshAdmin.Resource.polymorphic_tables/2","doc":"","ref":"AshAdmin.Resource.html#polymorphic_tables/2"},{"type":"function","title":"AshAdmin.Resource.polymorphic?/2","doc":"","ref":"AshAdmin.Resource.html#polymorphic?/2"},{"type":"function","title":"AshAdmin.Resource.read_actions/1","doc":"","ref":"AshAdmin.Resource.html#read_actions/1"},{"type":"function","title":"AshAdmin.Resource.relationship_display_fields/1","doc":"","ref":"AshAdmin.Resource.html#relationship_display_fields/1"},{"type":"function","title":"AshAdmin.Resource.resource_group/1","doc":"","ref":"AshAdmin.Resource.html#resource_group/1"},{"type":"function","title":"AshAdmin.Resource.show_action/1","doc":"","ref":"AshAdmin.Resource.html#show_action/1"},{"type":"function","title":"AshAdmin.Resource.table_columns/1","doc":"","ref":"AshAdmin.Resource.html#table_columns/1"},{"type":"function","title":"AshAdmin.Resource.update_actions/1","doc":"","ref":"AshAdmin.Resource.html#update_actions/1"},{"type":"module","title":"AshAdmin.Resource.Field","doc":"The representation of a configured field in the admin UI.","ref":"AshAdmin.Resource.Field.html"},{"type":"function","title":"AshAdmin.Resource.Field.schema/0","doc":"","ref":"AshAdmin.Resource.Field.html#schema/0"},{"type":"module","title":"AshAdmin.Resource.Transformers.ValidateTableColumns","doc":"Validates that table columns are all either attributes, or :one cardinality relationships.","ref":"AshAdmin.Resource.Transformers.ValidateTableColumns.html"},{"type":"function","title":"AshAdmin.Resource.Transformers.ValidateTableColumns.after_compile?/0","doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshAdmin.Resource.Transformers.ValidateTableColumns.html#after_compile?/0"},{"type":"function","title":"AshAdmin.Resource.Transformers.ValidateTableColumns.after?/1","doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"AshAdmin.Resource.Transformers.ValidateTableColumns.html#after?/1"},{"type":"function","title":"AshAdmin.Resource.Transformers.ValidateTableColumns.before?/1","doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"AshAdmin.Resource.Transformers.ValidateTableColumns.html#before?/1"},{"type":"function","title":"AshAdmin.Resource.Transformers.ValidateTableColumns.transform/1","doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"AshAdmin.Resource.Transformers.ValidateTableColumns.html#transform/1"},{"type":"module","title":"AshAdmin.Router","doc":"Provides LiveView routing for AshAdmin.","ref":"AshAdmin.Router.html"},{"type":"macro","title":"AshAdmin.Router.admin_browser_pipeline/1","doc":"Can be used to create a :browser pipeline easily if you don't have one. By default it is called :browser , but you can rename it by supplying an argument, for example: defmodule MyAppWeb.Router do use Phoenix.Router import AshAdmin.Router admin_browser_pipeline :something scope &quot;/&quot; do pipe_through [ :something ] ash_admin &quot;/admin&quot; end end","ref":"AshAdmin.Router.html#admin_browser_pipeline/1"},{"type":"macro","title":"AshAdmin.Router.ash_admin/2","doc":"Defines an AshAdmin route. It expects the path the admin dashboard will be mounted at and a set of options. Examples defmodule MyAppWeb.Router do use Phoenix.Router scope &quot;/&quot; do import AshAdmin.Router # Make sure you are piping through the browser pipeline # If you don&#39;t have one, see `admin_browser_pipeline/1` pipe_through [ :browser ] ash_admin &quot;/admin&quot; end end","ref":"AshAdmin.Router.html#ash_admin/2"},{"type":"module","title":"Demo.Accounts.Profile","doc":"","ref":"Demo.Accounts.Profile.html"},{"type":"function","title":"Demo.Accounts.Profile.apply_constraints_array/2","doc":"Callback implementation for Ash.Type.apply_constraints_array/2 .","ref":"Demo.Accounts.Profile.html#apply_constraints_array/2"},{"type":"function","title":"Demo.Accounts.Profile.cast_input/2","doc":"Callback implementation for Ash.Type.cast_input/2 .","ref":"Demo.Accounts.Profile.html#cast_input/2"},{"type":"function","title":"Demo.Accounts.Profile.cast_stored/2","doc":"Callback implementation for Ash.Type.cast_stored/2 .","ref":"Demo.Accounts.Profile.html#cast_stored/2"},{"type":"function","title":"Demo.Accounts.Profile.default_short_name/0","doc":"","ref":"Demo.Accounts.Profile.html#default_short_name/0"},{"type":"function","title":"Demo.Accounts.Profile.dump_to_native/2","doc":"Callback implementation for Ash.Type.dump_to_native/2 .","ref":"Demo.Accounts.Profile.html#dump_to_native/2"},{"type":"function","title":"Demo.Accounts.Profile.fetch_key/2","doc":"","ref":"Demo.Accounts.Profile.html#fetch_key/2"},{"type":"function","title":"Demo.Accounts.Profile.handle_change_array/3","doc":"Callback implementation for Ash.Type.handle_change_array/3 .","ref":"Demo.Accounts.Profile.html#handle_change_array/3"},{"type":"function","title":"Demo.Accounts.Profile.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Accounts.Profile.html#input/1"},{"type":"function","title":"Demo.Accounts.Profile.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Accounts.Profile.html#input/2"},{"type":"function","title":"Demo.Accounts.Profile.load/4","doc":"Callback implementation for Ash.Type.load/4 .","ref":"Demo.Accounts.Profile.html#load/4"},{"type":"function","title":"Demo.Accounts.Profile.prepare_change_array/3","doc":"Callback implementation for Ash.Type.prepare_change_array/3 .","ref":"Demo.Accounts.Profile.html#prepare_change_array/3"},{"type":"function","title":"Demo.Accounts.Profile.primary_key_matches?/2","doc":"","ref":"Demo.Accounts.Profile.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Accounts.Profile.spark_dsl_config/0","doc":"","ref":"Demo.Accounts.Profile.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Accounts.Profile.spark_is/0","doc":"","ref":"Demo.Accounts.Profile.html#spark_is/0"},{"type":"function","title":"Demo.Accounts.Profile.storage_type/0","doc":"Callback implementation for Ash.Type.storage_type/0 .","ref":"Demo.Accounts.Profile.html#storage_type/0"},{"type":"module","title":"Demo.Accounts.Registry","doc":"","ref":"Demo.Accounts.Registry.html"},{"type":"function","title":"Demo.Accounts.Registry.spark_dsl_config/0","doc":"","ref":"Demo.Accounts.Registry.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Accounts.Registry.spark_is/0","doc":"","ref":"Demo.Accounts.Registry.html#spark_is/0"},{"type":"module","title":"Demo.Accounts.User","doc":"","ref":"Demo.Accounts.User.html"},{"type":"function","title":"Demo.Accounts.User.default_short_name/0","doc":"","ref":"Demo.Accounts.User.html#default_short_name/0"},{"type":"function","title":"Demo.Accounts.User.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Accounts.User.html#input/1"},{"type":"function","title":"Demo.Accounts.User.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Accounts.User.html#input/2"},{"type":"function","title":"Demo.Accounts.User.primary_key_matches?/2","doc":"","ref":"Demo.Accounts.User.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Accounts.User.spark_dsl_config/0","doc":"","ref":"Demo.Accounts.User.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Accounts.User.spark_is/0","doc":"","ref":"Demo.Accounts.User.html#spark_is/0"},{"type":"module","title":"Demo.Repo","doc":"","ref":"Demo.Repo.html"},{"type":"function","title":"Demo.Repo.aggregate/3","doc":"Callback implementation for Ecto.Repo.aggregate/3 .","ref":"Demo.Repo.html#aggregate/3"},{"type":"function","title":"Demo.Repo.aggregate/4","doc":"Callback implementation for Ecto.Repo.aggregate/4 .","ref":"Demo.Repo.html#aggregate/4"},{"type":"function","title":"Demo.Repo.all/2","doc":"Callback implementation for Ecto.Repo.all/2 .","ref":"Demo.Repo.html#all/2"},{"type":"function","title":"Demo.Repo.all_tenants/0","doc":"Callback implementation for AshPostgres.Repo.all_tenants/0 .","ref":"Demo.Repo.html#all_tenants/0"},{"type":"function","title":"Demo.Repo.checked_out?/0","doc":"Callback implementation for Ecto.Repo.checked_out?/0 .","ref":"Demo.Repo.html#checked_out?/0"},{"type":"function","title":"Demo.Repo.checkout/2","doc":"Callback implementation for Ecto.Repo.checkout/2 .","ref":"Demo.Repo.html#checkout/2"},{"type":"function","title":"Demo.Repo.child_spec/1","doc":"","ref":"Demo.Repo.html#child_spec/1"},{"type":"function","title":"Demo.Repo.config/0","doc":"Callback implementation for Ecto.Repo.config/0 .","ref":"Demo.Repo.html#config/0"},{"type":"function","title":"Demo.Repo.default_options/1","doc":"Callback implementation for Ecto.Repo.default_options/1 .","ref":"Demo.Repo.html#default_options/1"},{"type":"function","title":"Demo.Repo.default_prefix/0","doc":"Callback implementation for AshPostgres.Repo.default_prefix/0 .","ref":"Demo.Repo.html#default_prefix/0"},{"type":"function","title":"Demo.Repo.delete!/2","doc":"Callback implementation for Ecto.Repo.delete!/2 .","ref":"Demo.Repo.html#delete!/2"},{"type":"function","title":"Demo.Repo.delete/2","doc":"Callback implementation for Ecto.Repo.delete/2 .","ref":"Demo.Repo.html#delete/2"},{"type":"function","title":"Demo.Repo.delete_all/2","doc":"Callback implementation for Ecto.Repo.delete_all/2 .","ref":"Demo.Repo.html#delete_all/2"},{"type":"function","title":"Demo.Repo.disconnect_all/2","doc":"A convenience function for SQL-based repositories that forces all connections in the pool to disconnect within the given interval. See Ecto.Adapters.SQL.disconnect_all/3 for more information.","ref":"Demo.Repo.html#disconnect_all/2"},{"type":"function","title":"Demo.Repo.exists?/2","doc":"Callback implementation for Ecto.Repo.exists?/2 .","ref":"Demo.Repo.html#exists?/2"},{"type":"function","title":"Demo.Repo.explain/3","doc":"A convenience function for SQL-based repositories that executes an EXPLAIN statement or similar depending on the adapter to obtain statistics for the given query. See Ecto.Adapters.SQL.explain/4 for more information.","ref":"Demo.Repo.html#explain/3"},{"type":"function","title":"Demo.Repo.from_ecto/1","doc":"","ref":"Demo.Repo.html#from_ecto/1"},{"type":"function","title":"Demo.Repo.get!/3","doc":"Callback implementation for Ecto.Repo.get!/3 .","ref":"Demo.Repo.html#get!/3"},{"type":"function","title":"Demo.Repo.get/3","doc":"Callback implementation for Ecto.Repo.get/3 .","ref":"Demo.Repo.html#get/3"},{"type":"function","title":"Demo.Repo.get_by!/3","doc":"Callback implementation for Ecto.Repo.get_by!/3 .","ref":"Demo.Repo.html#get_by!/3"},{"type":"function","title":"Demo.Repo.get_by/3","doc":"Callback implementation for Ecto.Repo.get_by/3 .","ref":"Demo.Repo.html#get_by/3"},{"type":"function","title":"Demo.Repo.get_dynamic_repo/0","doc":"Callback implementation for Ecto.Repo.get_dynamic_repo/0 .","ref":"Demo.Repo.html#get_dynamic_repo/0"},{"type":"function","title":"Demo.Repo.in_transaction?/0","doc":"Callback implementation for Ecto.Repo.in_transaction?/0 .","ref":"Demo.Repo.html#in_transaction?/0"},{"type":"function","title":"Demo.Repo.init/2","doc":"Callback implementation for Ecto.Repo.init/2 .","ref":"Demo.Repo.html#init/2"},{"type":"function","title":"Demo.Repo.insert!/2","doc":"Callback implementation for Ecto.Repo.insert!/2 .","ref":"Demo.Repo.html#insert!/2"},{"type":"function","title":"Demo.Repo.insert/2","doc":"Callback implementation for Ecto.Repo.insert/2 .","ref":"Demo.Repo.html#insert/2"},{"type":"function","title":"Demo.Repo.insert_all/3","doc":"Callback implementation for Ecto.Repo.insert_all/3 .","ref":"Demo.Repo.html#insert_all/3"},{"type":"function","title":"Demo.Repo.insert_or_update!/2","doc":"Callback implementation for Ecto.Repo.insert_or_update!/2 .","ref":"Demo.Repo.html#insert_or_update!/2"},{"type":"function","title":"Demo.Repo.insert_or_update/2","doc":"Callback implementation for Ecto.Repo.insert_or_update/2 .","ref":"Demo.Repo.html#insert_or_update/2"},{"type":"function","title":"Demo.Repo.installed_extensions/0","doc":"Callback implementation for AshPostgres.Repo.installed_extensions/0 .","ref":"Demo.Repo.html#installed_extensions/0"},{"type":"function","title":"Demo.Repo.load/2","doc":"Callback implementation for Ecto.Repo.load/2 .","ref":"Demo.Repo.html#load/2"},{"type":"function","title":"Demo.Repo.migrations_path/0","doc":"Callback implementation for AshPostgres.Repo.migrations_path/0 .","ref":"Demo.Repo.html#migrations_path/0"},{"type":"function","title":"Demo.Repo.min_pg_version/0","doc":"Callback implementation for AshPostgres.Repo.min_pg_version/0 .","ref":"Demo.Repo.html#min_pg_version/0"},{"type":"function","title":"Demo.Repo.on_transaction_begin/1","doc":"Callback implementation for AshPostgres.Repo.on_transaction_begin/1 .","ref":"Demo.Repo.html#on_transaction_begin/1"},{"type":"function","title":"Demo.Repo.one!/2","doc":"Callback implementation for Ecto.Repo.one!/2 .","ref":"Demo.Repo.html#one!/2"},{"type":"function","title":"Demo.Repo.one/2","doc":"Callback implementation for Ecto.Repo.one/2 .","ref":"Demo.Repo.html#one/2"},{"type":"function","title":"Demo.Repo.override_migration_type/1","doc":"Callback implementation for AshPostgres.Repo.override_migration_type/1 .","ref":"Demo.Repo.html#override_migration_type/1"},{"type":"function","title":"Demo.Repo.preload/3","doc":"Callback implementation for Ecto.Repo.preload/3 .","ref":"Demo.Repo.html#preload/3"},{"type":"function","title":"Demo.Repo.prepare_query/3","doc":"Callback implementation for Ecto.Repo.prepare_query/3 .","ref":"Demo.Repo.html#prepare_query/3"},{"type":"function","title":"Demo.Repo.put_dynamic_repo/1","doc":"Callback implementation for Ecto.Repo.put_dynamic_repo/1 .","ref":"Demo.Repo.html#put_dynamic_repo/1"},{"type":"function","title":"Demo.Repo.query!/3","doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query!/4 for more information.","ref":"Demo.Repo.html#query!/3"},{"type":"function","title":"Demo.Repo.query/3","doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query/4 for more information.","ref":"Demo.Repo.html#query/3"},{"type":"function","title":"Demo.Repo.query_many!/3","doc":"A convenience function for SQL-based repositories that executes the given multi-result query. See Ecto.Adapters.SQL.query_many!/4 for more information.","ref":"Demo.Repo.html#query_many!/3"},{"type":"function","title":"Demo.Repo.query_many/3","doc":"A convenience function for SQL-based repositories that executes the given multi-result query. See Ecto.Adapters.SQL.query_many/4 for more information.","ref":"Demo.Repo.html#query_many/3"},{"type":"function","title":"Demo.Repo.reload!/2","doc":"Callback implementation for Ecto.Repo.reload!/2 .","ref":"Demo.Repo.html#reload!/2"},{"type":"function","title":"Demo.Repo.reload/2","doc":"Callback implementation for Ecto.Repo.reload/2 .","ref":"Demo.Repo.html#reload/2"},{"type":"function","title":"Demo.Repo.rollback/1","doc":"Callback implementation for Ecto.Repo.rollback/1 .","ref":"Demo.Repo.html#rollback/1"},{"type":"function","title":"Demo.Repo.start_link/1","doc":"Callback implementation for Ecto.Repo.start_link/1 .","ref":"Demo.Repo.html#start_link/1"},{"type":"function","title":"Demo.Repo.stop/1","doc":"Callback implementation for Ecto.Repo.stop/1 .","ref":"Demo.Repo.html#stop/1"},{"type":"function","title":"Demo.Repo.stream/2","doc":"Callback implementation for Ecto.Repo.stream/2 .","ref":"Demo.Repo.html#stream/2"},{"type":"function","title":"Demo.Repo.tenant_migrations_path/0","doc":"Callback implementation for AshPostgres.Repo.tenant_migrations_path/0 .","ref":"Demo.Repo.html#tenant_migrations_path/0"},{"type":"function","title":"Demo.Repo.to_ecto/1","doc":"","ref":"Demo.Repo.html#to_ecto/1"},{"type":"function","title":"Demo.Repo.to_sql/2","doc":"A convenience function for SQL-based repositories that translates the given query to SQL. See Ecto.Adapters.SQL.to_sql/3 for more information.","ref":"Demo.Repo.html#to_sql/2"},{"type":"function","title":"Demo.Repo.transaction/2","doc":"Callback implementation for Ecto.Repo.transaction/2 .","ref":"Demo.Repo.html#transaction/2"},{"type":"function","title":"Demo.Repo.update!/2","doc":"Callback implementation for Ecto.Repo.update!/2 .","ref":"Demo.Repo.html#update!/2"},{"type":"function","title":"Demo.Repo.update/2","doc":"Callback implementation for Ecto.Repo.update/2 .","ref":"Demo.Repo.html#update/2"},{"type":"function","title":"Demo.Repo.update_all/3","doc":"Callback implementation for Ecto.Repo.update_all/3 .","ref":"Demo.Repo.html#update_all/3"},{"type":"module","title":"Demo.Tickets.Comment","doc":"","ref":"Demo.Tickets.Comment.html"},{"type":"function","title":"Demo.Tickets.Comment.default_short_name/0","doc":"","ref":"Demo.Tickets.Comment.html#default_short_name/0"},{"type":"function","title":"Demo.Tickets.Comment.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Tickets.Comment.html#input/1"},{"type":"function","title":"Demo.Tickets.Comment.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Tickets.Comment.html#input/2"},{"type":"function","title":"Demo.Tickets.Comment.primary_key_matches?/2","doc":"","ref":"Demo.Tickets.Comment.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Tickets.Comment.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.Comment.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.Comment.spark_is/0","doc":"","ref":"Demo.Tickets.Comment.html#spark_is/0"},{"type":"module","title":"Demo.Tickets.Customer","doc":"","ref":"Demo.Tickets.Customer.html"},{"type":"function","title":"Demo.Tickets.Customer.default_short_name/0","doc":"","ref":"Demo.Tickets.Customer.html#default_short_name/0"},{"type":"function","title":"Demo.Tickets.Customer.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Tickets.Customer.html#input/1"},{"type":"function","title":"Demo.Tickets.Customer.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Tickets.Customer.html#input/2"},{"type":"function","title":"Demo.Tickets.Customer.primary_key_matches?/2","doc":"","ref":"Demo.Tickets.Customer.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Tickets.Customer.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.Customer.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.Customer.spark_is/0","doc":"","ref":"Demo.Tickets.Customer.html#spark_is/0"},{"type":"module","title":"Demo.Tickets.Organization","doc":"","ref":"Demo.Tickets.Organization.html"},{"type":"function","title":"Demo.Tickets.Organization.default_short_name/0","doc":"","ref":"Demo.Tickets.Organization.html#default_short_name/0"},{"type":"function","title":"Demo.Tickets.Organization.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Tickets.Organization.html#input/1"},{"type":"function","title":"Demo.Tickets.Organization.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Tickets.Organization.html#input/2"},{"type":"function","title":"Demo.Tickets.Organization.primary_key_matches?/2","doc":"","ref":"Demo.Tickets.Organization.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Tickets.Organization.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.Organization.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.Organization.spark_is/0","doc":"","ref":"Demo.Tickets.Organization.html#spark_is/0"},{"type":"module","title":"Demo.Tickets.Registry","doc":"","ref":"Demo.Tickets.Registry.html"},{"type":"function","title":"Demo.Tickets.Registry.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.Registry.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.Registry.spark_is/0","doc":"","ref":"Demo.Tickets.Registry.html#spark_is/0"},{"type":"module","title":"Demo.Tickets.Representative","doc":"","ref":"Demo.Tickets.Representative.html"},{"type":"function","title":"Demo.Tickets.Representative.default_short_name/0","doc":"","ref":"Demo.Tickets.Representative.html#default_short_name/0"},{"type":"function","title":"Demo.Tickets.Representative.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Tickets.Representative.html#input/1"},{"type":"function","title":"Demo.Tickets.Representative.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Tickets.Representative.html#input/2"},{"type":"function","title":"Demo.Tickets.Representative.primary_key_matches?/2","doc":"","ref":"Demo.Tickets.Representative.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Tickets.Representative.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.Representative.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.Representative.spark_is/0","doc":"","ref":"Demo.Tickets.Representative.html#spark_is/0"},{"type":"module","title":"Demo.Tickets.Ticket","doc":"","ref":"Demo.Tickets.Ticket.html"},{"type":"function","title":"Demo.Tickets.Ticket.default_short_name/0","doc":"","ref":"Demo.Tickets.Ticket.html#default_short_name/0"},{"type":"function","title":"Demo.Tickets.Ticket.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Tickets.Ticket.html#input/1"},{"type":"function","title":"Demo.Tickets.Ticket.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Tickets.Ticket.html#input/2"},{"type":"function","title":"Demo.Tickets.Ticket.primary_key_matches?/2","doc":"","ref":"Demo.Tickets.Ticket.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Tickets.Ticket.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.Ticket.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.Ticket.spark_is/0","doc":"","ref":"Demo.Tickets.Ticket.html#spark_is/0"},{"type":"module","title":"Demo.Tickets.TicketLink","doc":"","ref":"Demo.Tickets.TicketLink.html"},{"type":"function","title":"Demo.Tickets.TicketLink.default_short_name/0","doc":"","ref":"Demo.Tickets.TicketLink.html#default_short_name/0"},{"type":"function","title":"Demo.Tickets.TicketLink.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Tickets.TicketLink.html#input/1"},{"type":"function","title":"Demo.Tickets.TicketLink.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Tickets.TicketLink.html#input/2"},{"type":"function","title":"Demo.Tickets.TicketLink.primary_key_matches?/2","doc":"","ref":"Demo.Tickets.TicketLink.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Tickets.TicketLink.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.TicketLink.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.TicketLink.spark_is/0","doc":"","ref":"Demo.Tickets.TicketLink.html#spark_is/0"},{"type":"extras","title":"AshAdmin","doc":"An admin UI for Ash resources. Built with Phoenix LiveView.","ref":"readme.html"},{"type":"extras","title":"AshAdmin - Demo","doc":"https://www.youtube.com/watch?v=aFMLz3cpQ8c","ref":"readme.html#demo"},{"type":"extras","title":"AshAdmin - Usage","doc":"First, ensure you've added ash_admin to your mix.exs file. { :ash_admin , &quot;~&gt; 0.9.1&quot; }","ref":"readme.html#usage"},{"type":"extras","title":"AshAdmin - Setup","doc":"Ensure your apis are configured in config.exs config :my_app , ash_apis : [ MyApp.Foo , MyApp.Bar ] Add the admin extension to each api you want to show in AshAdmin dashboard, and configure it to show. See AshAdmin.Api for more configuration options. # In your Api(s) use Ash.Api , extensions : [ AshAdmin.Api ] admin do show? true end Resources in each Api will be automagically included in AshAdmin. See AshAdmin.Resource for more resource configuration options. Specifically, if you app has an actor you will want to configure that. Ash Admin allows you to change actors and therefore doesn't rely on Ash.set_actor # In your resource that acts as an actor (e.g. User) use Ash.Resource , extensions : [ AshAdmin.Resource ] admin do actor? ( true ) end Modify your router to add AshAdmin at whatever path you'd like to serve it at. defmodule MyAppWeb.Router do use Phoenix.Router import AshAdmin.Router # AshAdmin requires a Phoenix LiveView `:browser` pipeline # If you DO NOT have a `:browser` pipeline already, then AshAdmin has a `:browser` pipeline # Most applications will not need this: admin_browser_pipeline :browser scope &quot;/&quot; do # Pipe it through your browser pipeline pipe_through [ :browser ] ash_admin &quot;/admin&quot; end end Note: there is no builtin security for your AshAdmin (except your apps normal policies). In most cases you will want to secure your AshAdmin routes in some way to prevent them from being public Now start your project (usually by running mix phx.server in a terminal) and visit /admin in your browser (or whatever path you gave to ash_admin in your router). Content Security Policy If your app specifies a content security policy header, eg. via plug :put_secure_browser_headers , %{ &quot;content-security-policy&quot; =&gt; &quot;default-src &#39;self&#39;&quot; } in your router, then all of the styles and JavaScript used to power AshAdmin will be blocked by your browser. To avoid this, you can add the specific AshAdmin nonces to the default-src allowlist, ie. plug :put_secure_browser_headers , %{ &quot;content-security-policy&quot; =&gt; &quot;default-src &#39;nonce-ash_admin-Ed55GFnX&#39; &#39;self&#39;&quot; } This will allow AshAdmin-generated inline CSS and JS blocks to execute normally.","ref":"readme.html#setup"},{"type":"extras","title":"AshAdmin - Configuration","doc":"See the documentation in AshAdmin.Resource and AshAdmin.Api for information on the available configuration.","ref":"readme.html#configuration"},{"type":"extras","title":"AshAdmin - Troubleshooting","doc":"If your Admin UI is not responding as expected. Check your browser's developer console for content-security-policy violations (see above).","ref":"readme.html#troubleshooting"},{"type":"extras","title":"AshAdmin - Development","doc":"To work on ash_admin, you'll want to be able to run the dev app. You'll need to have postgres setup locally, at which point you can do the following: mix ash_postgres.create mix migrate mix migrate_tenants mix setup Then, you can start the app with: mix dev If you make changes to the resources, you can generate migrations with mix generate_migrations","ref":"readme.html#development"},{"type":"extras","title":"AshAdmin - Contributors","doc":"Ash is made possible by its excellent community! Become a contributor","ref":"readme.html#contributors"}]